function vs= comp( ab, rs, rl, ord, mat);

%vs= comp( ab, rs, rl, ord, mat);
%
% Funkcia na vypocet poloh virtualnych zdrojov pre ucely 
% simulacie posluchoveho priestoru
%
% ab - rozmery miestnosti
% rs - poloha realneho zdroja zvuku
% rl - poloha realneho posluchaca
% ord- maximalny uvazovany rad odrazov
% mat- materialy jednotlivych stien m(1) - m(4)

 %%% VYPOCET POLOH VIRTUALNYCH ZDROJOV %%%
   
if ( ab(1) > ab(2) )
    maxD= ord* ab(1);
else
    maxD= ord* ab(2);
end;

ab= round(10000*ab)/10000;
vs(1,1:2)= round(10000*rs)/10000;
vs(1, 3:2+ord)= 0;

i= 0;
j= 1;
l= j;
sel1= 0;
sel2= 0;
tmp1= j;
mark= 0;
       
while ( mark == 0 )
    
    i= i+1;
    
    for k=l:j
        
        pos= (k-l+1)*4;
        
             %%% Zistenie polohy rozmnozovaneho virtualneho zdroja
               % pre potrebu pamatania si steny odrazu
        
        if (vs(k, 1)>0) zero(1)= fix(vs(k, 1)/ab(1))* ab(1);
        else zero(1)= (fix(vs(k, 1)/ab(1))- 1)* ab(1) ;
        end;
        
        if (vs(k, 2)>0) zero(2)= fix(vs(k, 2)/ab(2))* ab(2);
        else zero(2)= (fix(vs(k, 2)/ab(2))- 1)* ab(2) ;
        end;
            
        x= zero(1)+ ab(1)- vs(k, 1);
        y= zero(2)+ ab(2)- vs(k, 2);
         
        if ( fix(zero(1)/ab(1)/2) == zero(1)/ab(1)/2 )
            m= 1;
        else
            m=0;
        end;
        if ( fix(zero(2)/ab(2)/2) == zero(2)/ab(2)/2 )
            n= 1;
        else
            n=0;
        end;
            
        a= round(10000* (ab(1)- x +zero(1)))/10000; %odraz nahor
        b= round(10000* (ab(2)+ y +zero(2)))/10000;
        tmp( pos-3, 1:2)= [a b];
        tmp( pos-3, 3:1+i)= vs(k, 3:1+i);
        if (n == 1) tmp( pos-3, 2+i)= mat(1);
        else tmp( pos-3, 2+i)= mat(3);
        end;
            
        a= round(10000* (ab(1)+ x +zero(1)))/10000; %odraz vpravo
        b= round(10000* (ab(2)- y +zero(2)))/10000;
        tmp( pos-2, 1:2)= [a b];
        tmp( pos-2, 3:1+i)= vs(k, 3:1+i);
        if (m == 1) tmp( pos-2, 2+i)= mat(2);
        else tmp( pos-2, 2+i)= mat(4);
        end

        a= round(10000* (ab(1)- x +zero(1)))/10000;  %odraz nadol
        b= round(10000* (-ab(2)+ y +zero(2)))/10000;
        tmp( pos-1, 1:2)= [a b];
        tmp( pos-1, 3:1+i)= vs(k, 3:1+i);
        if (n == 1) tmp( pos-1, 2+i)= mat(3);
        else tmp( pos-1, 2+i)= mat(1);
        end

        a= round(10000* (-ab(1)+ x +zero(1)))/10000; %odraz vlavo
        b= round(10000* (ab(2)- y +zero(2)))/10000;
        tmp( pos,   1:2)= [a b];
        tmp( pos, 3:1+i)= vs(k, 3:1+i);
        if (m == 1) tmp( pos, 2+i)= mat(4);
        else tmp(pos, 2+i)= mat(2);
        end

    end;
    
    pr= 0;
    [q r]= size(tmp);
    [n o]= size(vs);
    
    
        
            %zapis najdenych vs
    
    for p= 1:q          %porovnanie vsetkych najdenych vs
                        %porovnanie s kazdym uz ulozenym vs
        for m= 1:n
            if( tmp(p, 1:2) == vs(m, 1:2) )
                pr= 1;
                break;
            end;
        end;
                           % ak vs je novy, zapise sa do zoznamu
        if ( pr ~= 1 )
            
            sel1= sel1+ 1;
            a= tmp(p, 1)- rl(1);
            b= tmp(p, 2)- rl(2);
            c= sqrt( a^2 + b^2);

            if ( c < maxD )     % zapise sa len ak je blizsie, nez Dmax
                
                if( r > o )
                    vs(1, r)= 0;
                end;
                
                j= j+1;
                vs(j, 1:r)= tmp(p, 1:r);
                n= n+1;
            else
                sel2= sel2+ 1;                
            end;
        end; 
        
        pr= 0;
        
    end;
    
    if ( sel1 == sel2 )
        mark= 1;
    else 
        sel1= 0;
        sel2= 0;
    end;
    
    tmp= 0;
    l= tmp1+1;
    tmp1= j;

end;

 %%% VYKRESLENIE VIRTUALNYCH ZDROJOV %%%
 
% a= max( vs);
% b= min( vs);
% 
% x1= ceil( a(1)/ ab(1)+ 1)*ab(1);
% x2= ceil( b(1)/ ab(1)- 2)*ab(1);
% y1= ceil( a(2)/ ab(2)+ 1)*ab(2);
% y2= ceil( b(2)/ ab(2)- 2)*ab(2);
% 
% 
% figure(1);
% hold on;
% 
% for j=-i:i
%    plot(ones(1,1000)*(j+1)*ab(1),linspace( y2, y1+ab(2), 1000),'k');
%    plot(linspace( x2, x1+ab(1), 1000),ones(1,1000)*((j+1)*ab(2)),'k');
% end;
% 
% axis([ x2, x1, y2, y1]);
% plot( vs(1:length(vs), 1), vs(1:length(vs), 2),'b.'); 
% plot( vs(1, 1), vs(1, 2), 'ro');
% plot( rl(1), rl(2), 'r.');



 %%% VYPOCET VZDIALENOSTI A UHLOV DOPADU JEDNOTLIVYCH VS OD RL %%%
 
for i= 1:length(vs)
     
     a= vs(i, 1)- rl(1);
     b= vs(i, 2)- rl(2);
     c= sqrt( a^2 + b^2);
     fi= asin(a/c)/pi* 180;
     
     if ( ( b<0 ) || ( b==0 && a<0 ) )
         fi= 180- fi;
     end;
     
     vs(i, 1)= fi;
     vs(i, 2)= c;
end;